Index: trunk/modules/vci_cc_xcache_wrapper_v4/caba/source/src/vci_cc_xcache_wrapper_v4.cpp
===================================================================
--- trunk/modules/vci_cc_xcache_wrapper_v4/caba/source/src/vci_cc_xcache_wrapper_v4.cpp	(revision 134)
+++ trunk/modules/vci_cc_xcache_wrapper_v4/caba/source/src/vci_cc_xcache_wrapper_v4.cpp	(revision 140)
@@ -326,16 +590,47 @@
                 cache_info.dcache_assoc     = dcache_ways;
                 cache_info.dcache_n_lines   = dcache_sets;
-                m_iss.setCacheInfo(cache_info);
-
+
+                for (uint32_t num_cpu=0; num_cpu<m_nb_cpu; ++num_cpu)
+                    m_iss[num_cpu]->setCacheInfo(cache_info);
+                
 #if CC_XCACHE_WRAPPER_STOP_SIMULATION
                 m_stop_simulation               = false;
-                m_stop_simulation_nb_frz_cycles = 0;
+                m_stop_simulation_nb_frz_cycles = new uint32_t [m_nb_cpu];
+                for (uint32_t num_cpu=0; num_cpu<m_nb_cpu; ++num_cpu)
+                m_stop_simulation_nb_frz_cycles [num_cpu] = 0;
 #endif // CC_XCACHE_WRAPPER_STOP_SIMULATION
 
-#if CC_XCACHE_WRAPPER_DEBUG_DCACHE_TRANSACTION
-                std::ostringstream filename("");
-                filename << "Instruction_flow_" << proc_id << ".log";
-                
-                log_dcache_transaction_file.open(filename.str().c_str() ,std::ios::out | std::ios::trunc);
+#if CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
+                log_transaction_file_icache = new std::ofstream [m_nb_cpu];
+                log_transaction_file_dcache = new std::ofstream [m_nb_cpu];
+                for (uint32_t num_cpu=0; num_cpu<m_nb_cpu; ++num_cpu)
+                {
+                    {
+                        std::ostringstream filename("");
+                        filename << CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION_PATH << "/Transaction_icache-" << proc_id << "_" << num_cpu << ".log";
+                        log_transaction_file_icache[num_cpu].open(filename.str().c_str() ,std::ios::out | std::ios::trunc);
+                    }
+                    {
+                        std::ostringstream filename("");
+                        filename << CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION_PATH << "/Transaction_dcache-" << proc_id << "_" << num_cpu << ".log";
+                        log_transaction_file_dcache[num_cpu].open(filename.str().c_str() ,std::ios::out | std::ios::trunc);
+                    }
+                }
+
+                {
+                    std::ostringstream filename("");
+                    filename << CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION_PATH << "/Transaction_cmd-" << proc_id << ".log";
+                    log_transaction_file_cmd.open(filename.str().c_str() ,std::ios::out | std::ios::trunc);
+                }
+                {
+                    std::ostringstream filename("");
+                    filename << CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION_PATH << "/Transaction_tgt-" << proc_id << ".log";
+                    log_transaction_file_tgt.open(filename.str().c_str() ,std::ios::out | std::ios::trunc);
+                }
+                {
+                    std::ostringstream filename("");
+                    filename << CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION_PATH << "/Transaction_cleanup-" << proc_id << ".log";
+                    log_transaction_file_cleanup.open(filename.str().c_str() ,std::ios::out | std::ios::trunc);
+                }
 #endif
             } // end constructor
@@ -345,12 +640,127 @@
     ///////////////////////////////////
     {
-#if CC_XCACHE_WRAPPER_DEBUG_DCACHE_TRANSACTION
-        log_dcache_transaction_file.close();
-#endif
-
+        delete [] m_stop_simulation_nb_frz_cycles;
+
+#if CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
+        for (uint32_t num_cpu=0; num_cpu<m_nb_cpu; ++num_cpu)
+        {
+            log_transaction_file_dcache[num_cpu].close();
+            log_transaction_file_icache[num_cpu].close();
+        }
+        delete [] log_transaction_file_dcache;
+        delete [] log_transaction_file_icache;
+
+        log_transaction_file_cmd    .close();
+        log_transaction_file_tgt    .close();
+        log_transaction_file_cleanup.close();
+#endif
+
+        delete [] r_icache_lock         ;
+        delete [] r_dcache_lock         ;
+        delete [] r_dcache_sync         ;
+
+        delete [] r_icache_fsm          ;
+        delete [] r_icache_fsm_save     ;
+        delete [] r_icache_addr_save    ;
+        delete [] r_icache_miss_req     ;
+        delete [] r_icache_miss_way     ;
+        delete [] r_icache_miss_set     ;
+        delete [] r_icache_unc_req      ;
+        delete [] r_icache_cleanup_req  ;
+        delete [] r_icache_cleanup_line ;
+        delete [] r_icache_inval_rsp    ;
+        delete [] r_icache_update_addr  ;
+        delete [] r_icache_buf_unc_valid;
+
+        delete [] r_dcache_fsm          ;
+        delete [] r_dcache_fsm_save     ;
+        delete [] r_dcache_addr_save    ;
+        delete [] r_dcache_wdata_save   ;
+        delete [] r_dcache_rdata_save   ;
+        delete [] r_dcache_type_save    ;
+        delete [] r_dcache_be_save      ;
+        delete [] r_dcache_cached_save  ;
+        delete [] r_dcache_cleanup_req  ;
+        delete [] r_dcache_cleanup_line ;
+        delete [] r_dcache_miss_req     ;
+        delete [] r_dcache_miss_way     ;
+        delete [] r_dcache_miss_set     ;
+        delete [] r_dcache_unc_req      ;
+        delete [] r_dcache_sc_req       ;
+        delete [] r_dcache_inval_rsp    ;
+        delete [] r_dcache_update_addr  ;
+        delete [] r_dcache_previous_unc ;
+
+        for (uint32_t num_cache=0; num_cache<m_nb_dcache; ++num_cache)
+        {
+            delete [] r_dcache_ll_data    [num_cache];
+            delete [] r_dcache_ll_addr    [num_cache];
+            delete [] r_dcache_ll_valid   [num_cache];
+        }
+        delete [] r_dcache_num_cpu_save ;
+        delete [] r_dcache_ll_data      ;
+        delete [] r_dcache_ll_addr      ;
+        delete [] r_dcache_ll_valid     ;
+
+        delete [] r_tgt_icache_req      ;
+        delete [] r_tgt_icache_rsp      ;
+        delete [] r_tgt_dcache_req      ;
+        delete [] r_tgt_dcache_rsp      ;
+
+        delete [] r_tgt_be ;
         delete [] r_tgt_buf;
-        delete [] r_tgt_be ;
+
+        delete [] r_vci_rsp_ins_error   ;
+        delete [] r_vci_rsp_data_error  ;
+
+        delete [] ireq           ;
+        delete [] irsp           ;
+        delete [] ireq_cached    ;
+        delete [] ireq_num_cpu   ;
+        delete [] dreq           ;
+        delete [] drsp           ;
+        delete [] dreq_cached    ;
+        delete [] dreq_num_cpu   ;
+
+        delete [] m_cpt_frz_cycles;
+
+        delete [] m_cpt_icache_access   ;
+        delete [] m_cpt_dcache_access   ;
+
+        for (uint32_t num_cache=0; num_cache<m_nb_dcache; ++num_cache)
+        delete [] m_cpt_fsm_dcache [num_cache];
+        for (uint32_t num_cache=0; num_cache<m_nb_icache; ++num_cache)
+        delete [] m_cpt_fsm_icache [num_cache];
+        
+        delete [] m_cpt_fsm_dcache ;
+        delete [] m_cpt_fsm_icache ;
+        delete [] m_cpt_fsm_cmd    ;
+        delete [] m_cpt_fsm_rsp    ;
+        delete [] m_cpt_fsm_tgt    ;
+        delete [] m_cpt_fsm_cleanup;
+
+        for (uint32_t num_cache=0; num_cache<m_nb_icache; ++num_cache)
+        {
+            delete r_icache [num_cache];
+        }
+        for (uint32_t num_cache=0; num_cache<m_nb_dcache; ++num_cache)
+        {
+            delete r_wbuf   [num_cache];
+            delete r_dcache [num_cache];
+        }
+        delete [] r_wbuf;
+        delete [] r_icache;
+        delete [] r_dcache;
+
 
         CACHE_MISS_BUF_DEALLOC;
+
+        for (uint32_t num_cpu=0; num_cpu<m_nb_cpu; ++num_cpu)
+        {
+            delete    m_iss [num_cpu];
+            delete [] p_irq [num_cpu];
+        }
+        delete [] m_iss;
+        delete [] p_irq;
     }
 
@@ -359,6 +769,7 @@
     ////////////////////////
     {
+        for (uint32_t num_cpu=0; num_cpu<m_nb_cpu; ++num_cpu)
         std::cout << "CPU " << m_srcid_rw << " : CPI = " 
-            << (float)m_cpt_total_cycles/(m_cpt_total_cycles - m_cpt_frz_cycles) << std::endl ;
+                  << (float)m_cpt_total_cycles/(m_cpt_total_cycles - m_cpt_frz_cycles[num_cpu]) << std::endl ;
     }
     ////////////////////////
@@ -366,12 +777,15 @@
     ////////////////////////
     {
-        float run_cycles = (float)(m_cpt_total_cycles - m_cpt_frz_cycles);
-
         uint32_t m_cpt_data_read_cached  = m_cpt_data_read-m_cpt_data_read_uncached;
         uint32_t m_cpt_data_write_cached = m_cpt_data_write-m_cpt_data_write_uncached;
         std::cout << "------------------------------------" << std:: dec << std::endl;
         std::cout << "CPU " << m_srcid_rw << " / Time = " << m_cpt_total_cycles << std::endl;
-        std::cout << "- CPI                            : " << (float)m_cpt_total_cycles/run_cycles << std::endl ;
-        std::cout << "- IPC                            : " << (float)run_cycles/m_cpt_total_cycles << std::endl ;
+        for (uint32_t num_cpu=0; num_cpu<m_nb_cpu; ++num_cpu)
+        {
+            float run_cycles = (float)(m_cpt_total_cycles - m_cpt_frz_cycles[num_cpu]);
+
+            std::cout << "- CPI                            : [" << num_cpu << "] "<< (float)m_cpt_total_cycles/run_cycles << std::endl ;
+            std::cout << "- IPC                            : [" << num_cpu << "] "<< (float)run_cycles/m_cpt_total_cycles << std::endl ;
+        }
         std::cout << "- DATA READ *                    : " << m_cpt_data_read << std::endl ;
         std::cout << "  + Uncached                     : " << m_cpt_data_read_uncached << " (" << (float)m_cpt_data_read_uncached*100.0/(float)m_cpt_data_read << "%)" << std::endl ;
@@ -404,7 +818,54 @@
         std::cout << "  + DCACHE Only                  : " << (float)m_cpt_cc_inval_dcache   *100.0/(float)m_cpt_cc_inval << "%" << std::endl;
         std::cout << "  + BROADCAST                    : " << (float)m_cpt_cc_inval_broadcast*100.0/(float)m_cpt_cc_inval << "%" << std::endl;
+
+        uint32_t m_cpt_icache_access_all = 0;
+        for (uint32_t num_cache=0; num_cache<m_nb_icache; ++num_cache)
+            m_cpt_icache_access_all += m_cpt_icache_access [num_cache];
+
+        std::cout << "- ICACHE ACCESS                  : " << m_cpt_icache_access_all << std::endl;
+        for (uint32_t num_cache=0; num_cache<m_nb_icache; ++num_cache)
+            std::cout << "  + [" << num_cache << "] : " << m_cpt_icache_access [num_cache] << " (" << (float)m_cpt_icache_access [num_cache]*100.0/(float)m_cpt_icache_access_all << "%)" << std::endl;
+
+        uint32_t m_cpt_dcache_access_all = 0;
+        for (uint32_t num_cache=0; num_cache<m_nb_dcache; ++num_cache)
+            m_cpt_dcache_access_all += m_cpt_dcache_access [num_cache];
+
+        std::cout << "- DCACHE ACCESS                  : " << m_cpt_dcache_access_all << std::endl;
+        for (uint32_t num_cache=0; num_cache<m_nb_dcache; ++num_cache)
+            std::cout << "  + [" << num_cache << "] : " << m_cpt_dcache_access [num_cache] << " (" << (float)m_cpt_dcache_access [num_cache]*100.0/(float)m_cpt_dcache_access_all << "%)" << std::endl;
+
+        std::cout << "- DCACHE FSM" << std::endl;
+        for (uint32_t i=0; i<soclib::common::size(dcache_fsm_state_str ); ++i)
+        {
+            std::cout << "  + "  << dcache_fsm_state_str[i] << " :\t ";
+            for (uint32_t num_cache=0; num_cache<m_nb_dcache; ++num_cache)
+                std::cout << m_cpt_fsm_dcache [num_cache][i] << ", ";
+            std::cout << std::endl; 
+        }
+        std::cout << "- ICACHE FSM" << std::endl;
+        for (uint32_t i=0; i<soclib::common::size(icache_fsm_state_str ); ++i)
+        {
+            std::cout << "  + "  << icache_fsm_state_str[i] << " :\t ";
+            for (uint32_t num_cache=0; num_cache<m_nb_icache; ++num_cache)
+                std::cout << m_cpt_fsm_icache [num_cache][i] << ", ";
+            std::cout << std::endl; 
+        }
+        std::cout << "- CMD FSM" << std::endl;
+        for (uint32_t i=0; i<soclib::common::size(cmd_fsm_state_str ); ++i)
+            std::cout << "  + " << cmd_fsm_state_str[i] << " :\t " << m_cpt_fsm_cmd [i] << std::endl;
+        std::cout << "- RSP FSM" << std::endl;
+        for (uint32_t i=0; i<soclib::common::size(rsp_fsm_state_str ); ++i)
+            std::cout << "  + " << rsp_fsm_state_str[i] << " :\t " << m_cpt_fsm_rsp [i] << std::endl;
+        std::cout << "- TGT FSM" << std::endl;
+        for (uint32_t i=0; i<soclib::common::size(tgt_fsm_state_str ); ++i)
+            std::cout << "  + "  << tgt_fsm_state_str[i] << " :\t " << m_cpt_fsm_tgt [i] << std::endl;
+        std::cout << "- CLEANUP FSM" << std::endl;
+        for (uint32_t i=0; i<soclib::common::size(cleanup_fsm_state_str ); ++i)
+            std::cout << "  + "  << cleanup_fsm_state_str[i] << " :\t " << m_cpt_fsm_cleanup [i] << std::endl;
+
         std::cout << "* : accepted or not by the cache" << std::endl ;
 
-        r_wbuf.printStatistics();
+        for (uint32_t num_cache=0; num_cache<m_nb_dcache; ++num_cache)
+            r_wbuf[num_cache]->printStatistics();
     }
 
@@ -421,11 +882,18 @@
         typename iss_t::DataRequest         dreq;
 
-        m_iss.getRequests( ireq, dreq );
         std::cout << std::dec << "Proc \"" << name() << "\"" << std::endl;
-        std::cout << ireq << std::endl;
-        std::cout << dreq << std::endl;
-        std::cout << "  " << dcache_fsm_state_str[r_dcache_fsm]
-                  << "  " << icache_fsm_state_str[r_icache_fsm]
-                  << "  " << cmd_fsm_state_str[r_vci_cmd_fsm]
+
+        for (uint32_t num_cpu=0; num_cpu<m_nb_cpu; ++num_cpu)
+        {
+            m_iss[num_cpu]->getRequests( ireq, dreq );
+            std::cout << ireq << std::endl;
+            std::cout << dreq << std::endl;
+        }
+        for (uint32_t num_cache=0; num_cache<m_nb_icache; ++num_cache)
+        std::cout << "  " << icache_fsm_state_str[r_icache_fsm[num_cache]] << std::endl;
+        for (uint32_t num_cache=0; num_cache<m_nb_dcache; ++num_cache)
+        std::cout << "  " << dcache_fsm_state_str[r_dcache_fsm[num_cache]] << std::endl;
+            
+        std::cout << "  " << cmd_fsm_state_str[r_vci_cmd_fsm]
                   << "  " << rsp_fsm_state_str[r_vci_rsp_fsm]
                   << "  " << tgt_fsm_state_str[r_vci_tgt_fsm]
@@ -434,27 +902,19 @@
         if(mode & 0x1)
         {
-            r_wbuf.printTrace((mode>>1)&1);
+            for (uint32_t num_cache=0; num_cache<m_nb_dcache; ++num_cache)
+                r_wbuf[num_cache]->printTrace((mode>>1)&1);
         }
         if(mode & 0x4)
         {
             std::cout << "  Data cache" << std::endl;
-            r_dcache.printTrace();
+            for (uint32_t num_cache=0; num_cache<m_nb_dcache; ++num_cache)
+                r_dcache[num_cache]->printTrace();
         }
         if(mode & 0x8)
         {
             std::cout << "  Instruction cache" << std::endl;
-            r_icache.printTrace();
+            for (uint32_t num_cache=0; num_cache<m_nb_icache; ++num_cache)
+                r_icache[num_cache]->printTrace();
         }
-
-        // if(mode & 0x10)
-        // {
-        //     std::cout << "  Icache miss buffer : ";
-        //     CACHE_MISS_BUF_RSP_PRINT(i);
-        //     std::cout << std::endl;
-
-        //     std::cout << "  Dcache miss buffer : ";
-        //     CACHE_MISS_BUF_RSP_PRINT(d);
-        //     std::cout << std::endl;
-        // }
     }
 
@@ -465,9 +925,24 @@
         if ( not p_resetn.read() ) {
 
-            m_iss.reset();
+            r_cpu_prior = 0;
+
+            for (uint32_t num_cpu=0; num_cpu<m_nb_cpu; ++num_cpu)
+                m_iss[num_cpu]->reset();
 
             // FSM states
-            r_dcache_fsm  = DCACHE_IDLE;
-            r_icache_fsm  = ICACHE_IDLE;
+            for (uint32_t num_cache=0; num_cache<m_nb_icache; ++num_cache)
+            {
+                r_icache_fsm [num_cache] = ICACHE_IDLE;
+
+                r_icache_lock[num_cache] = m_nb_cpu;
+            }
+            for (uint32_t num_cache=0; num_cache<m_nb_dcache; ++num_cache)
+            {
+                r_dcache_fsm [num_cache] = DCACHE_IDLE;
+
+                r_dcache_lock[num_cache] = m_nb_cpu;
+                r_dcache_sync[num_cache] = false;
+            }
+
             r_vci_cmd_fsm = CMD_IDLE;
             r_vci_rsp_fsm = RSP_IDLE;
@@ -475,24 +950,53 @@
             r_cleanup_fsm = CLEANUP_IDLE;
 
+            for (uint32_t num_cache=0; num_cache<m_nb_icache; ++num_cache)
+            {
             // write buffer & caches
-            r_wbuf.reset();
-            r_icache.reset();
-            r_dcache.reset();
+            r_icache[num_cache]->reset();
 
             // synchronisation flip-flops from ICACHE & DCACHE FSMs to VCI  FSMs
-            r_icache_miss_req    = false;
-            r_icache_unc_req     = false;
-            r_icache_cleanup_req = false;
-            r_dcache_miss_req    = false;
-            r_dcache_unc_req     = false;
-            r_dcache_sc_req      = false;
-            r_dcache_cleanup_req = false;
-            r_dcache_previous_unc= false;
+            r_icache_miss_req    [num_cache] = false;
+            r_icache_unc_req     [num_cache] = false;
+            r_icache_cleanup_req [num_cache] = false;
+
+            // internal messages in DCACHE et ICACHE FSMs
+            r_icache_inval_rsp   [num_cache] = false;
+
+            // error signals from the VCI RSP FSM to the ICACHE or DCACHE FSMs
+            r_icache_buf_unc_valid [num_cache] = false;
 
             // synchronisation flip-flops from TGT FSM to ICACHE & DCACHE FSMs
-            r_tgt_icache_req     = false;
-            r_tgt_dcache_req     = false;
-            r_tgt_icache_rsp     = false;
-            r_tgt_dcache_rsp     = false;
+            r_tgt_icache_req     [num_cache] = false;
+            r_tgt_icache_rsp     [num_cache] = false;
+
+            r_vci_rsp_ins_error  [num_cache] = false;
+            }// end for num_cache
+
+            for (uint32_t num_cache=0; num_cache<m_nb_dcache; ++num_cache)
+            {
+            // write buffer & caches
+            r_wbuf  [num_cache]->reset();
+            r_dcache[num_cache]->reset();
+
+            // synchronisation flip-flops from ICACHE & DCACHE FSMs to VCI  FSMs
+            r_dcache_miss_req    [num_cache] = false;
+            r_dcache_unc_req     [num_cache] = false;
+            r_dcache_sc_req      [num_cache] = false;
+            r_dcache_cleanup_req [num_cache] = false;
+            r_dcache_previous_unc[num_cache] = false;
+
+            // internal messages in DCACHE et ICACHE FSMs
+            r_dcache_inval_rsp   [num_cache] = false;
+
+            // error signals from the VCI RSP FSM to the ICACHE or DCACHE FSMs
+            for (uint32_t num_cpu=0; num_cpu<m_nb_cpu; ++num_cpu)
+                r_dcache_ll_valid      [num_cache][num_cpu] = false;
+
+            // synchronisation flip-flops from TGT FSM to ICACHE & DCACHE FSMs
+            r_tgt_dcache_req     [num_cache] = false;
+            r_tgt_dcache_rsp     [num_cache] = false;
+
+            r_vci_rsp_data_error [num_cache] = false;
+            }// end for num_cache
 
 #if CC_XCACHE_WRAPPER_CC_UPDATE_MULTI_CYCLE
@@ -500,17 +1004,5 @@
 #endif
 
-
-            // internal messages in DCACHE et ICACHE FSMs
-            r_icache_inval_rsp   = false;
-            r_dcache_inval_rsp   = false;
-
-            // error signals from the VCI RSP FSM to the ICACHE or DCACHE FSMs
-            r_dcache_ll_valid      = false;
-            r_icache_buf_unc_valid = false;
-
             r_vci_cmd_dcache_prior = false;
-
-            r_vci_rsp_data_error   = false;
-            r_vci_rsp_ins_error    = false;
 
             CACHE_MISS_BUF_RESET(i);
@@ -535,5 +1027,6 @@
             m_cpt_cc_update_dcache_word_useful = 0;
 
-            m_cpt_frz_cycles   = 0;
+            for (uint32_t num_cpu=0; num_cpu<m_nb_cpu; ++num_cpu)
+            m_cpt_frz_cycles [num_cpu]  = 0;
             m_cpt_total_cycles = 0;
 
@@ -563,4 +1056,28 @@
             m_length_write_transaction = 0;
 
+            for (uint32_t num_cache=0; num_cache<m_nb_icache; ++num_cache)
+            {
+                m_cpt_icache_access [num_cache] = 0;
+
+                for (uint32_t i=0; i<soclib::common::size(icache_fsm_state_str ); ++i)
+                    m_cpt_fsm_icache  [num_cache][i] = 0;
+            }
+            for (uint32_t num_cache=0; num_cache<m_nb_dcache; ++num_cache)
+            {
+                m_cpt_dcache_access [num_cache] = 0;
+
+                for (uint32_t i=0; i<soclib::common::size(dcache_fsm_state_str ); ++i)
+                    m_cpt_fsm_dcache  [num_cache][i] = 0;
+            }
+
+            for (uint32_t i=0; i<soclib::common::size(cmd_fsm_state_str    ); ++i)
+                m_cpt_fsm_cmd     [i] = 0;
+            for (uint32_t i=0; i<soclib::common::size(rsp_fsm_state_str    ); ++i)
+                m_cpt_fsm_rsp     [i] = 0;
+            for (uint32_t i=0; i<soclib::common::size(tgt_fsm_state_str    ); ++i)
+                m_cpt_fsm_tgt     [i] = 0;
+            for (uint32_t i=0; i<soclib::common::size(cleanup_fsm_state_str); ++i)
+                m_cpt_fsm_cleanup [i] = 0;
+
             return;
         }
@@ -569,22 +1086,43 @@
 
         PRINTF("--------------------------------------------\n");
-        PRINTF("  * CC_XCACHE_WRAPPER \"%s\" - Time = %d\n",name().c_str(),(uint32_t)m_cpt_total_cycles);
-        PRINTF("    * fsm dcache          = %s\n",dcache_fsm_state_str[r_dcache_fsm]);
-        PRINTF("    * fsm icache          = %s\n",icache_fsm_state_str[r_icache_fsm]);
-        PRINTF("    * fsm cmd             = %s\n",cmd_fsm_state_str[r_vci_cmd_fsm]);
-        PRINTF("    * fsm rsp             = %s\n",rsp_fsm_state_str[r_vci_rsp_fsm]);
-        PRINTF("    * fsm tgt             = %s\n",tgt_fsm_state_str[r_vci_tgt_fsm]);
-        PRINTF("    * fsm cleanup         = %s\n",cleanup_fsm_state_str[r_cleanup_fsm]);
-        PRINTF("    * ll info             : %d %llx %llx\n",r_dcache_ll_valid.read(), (uint64_t)r_dcache_ll_addr.read(), (uint64_t)r_dcache_ll_data.read());
-        PRINTF("    * dcache_previous_unc : %d\n",r_dcache_previous_unc.read());
+        PRINTF("  * CC_XCACHE_WRAPPER \"%s\" Transition - Time = %d\n",name().c_str(),(uint32_t)m_cpt_total_cycles);
+        for (uint32_t num_cache=0; num_cache<m_nb_dcache; ++num_cache)
+        PRINTF("    * fsm dcache              = [%.2d] %s - (%.2d) %llx (%llx)\n",num_cache,dcache_fsm_state_str[r_dcache_fsm[num_cache]],r_dcache_lock[num_cache].read(),(uint64_t)r_dcache_addr_save[num_cache].read(),(uint64_t)set_num_dcache_only(r_dcache_addr_save[num_cache].read(),num_cache));
+        for (uint32_t num_cache=0; num_cache<m_nb_icache; ++num_cache)
+        PRINTF("    * fsm icache              = [%.2d] %s - (%.2d) %llx (%llx)\n",num_cache,icache_fsm_state_str[r_icache_fsm[num_cache]],r_icache_lock[num_cache].read(),(uint64_t)r_icache_addr_save[num_cache].read(),(uint64_t)set_num_icache_only(r_icache_addr_save[num_cache].read(),num_cache));
+        PRINTF("    * fsm cmd                 = (%.2d) %s\n",r_vci_cmd_num_cache.read(), cmd_fsm_state_str[r_vci_cmd_fsm]);
+        PRINTF("    * fsm rsp                 = (%.2d) %s\n",r_vci_rsp_num_cache.read(), rsp_fsm_state_str[r_vci_rsp_fsm]);
+        PRINTF("    * fsm tgt                 = (%.2d) %s - i %llx d %llx\n",r_tgt_num_cache.read(), tgt_fsm_state_str[r_vci_tgt_fsm],(uint64_t)r_tgt_iaddr.read(),(uint64_t)r_tgt_daddr.read());
+      //PRINTF("    * fsm tgt                 =      %s - %llx\n",tgt_fsm_state_str[r_vci_tgt_fsm],(uint64_t)r_tgt_addr.read());
+        PRINTF("    * fsm cleanup             = (%.2d) %s\n",r_cleanup_num_cache.read(), cleanup_fsm_state_str[r_cleanup_fsm]);
+        for (uint32_t num_cache=0; num_cache<m_nb_dcache; ++num_cache)
+        {
+            for (uint32_t num_cpu=0; num_cpu<m_nb_cpu; ++num_cpu)
+                PRINTF("    * ll info                 : [%.2d][%.2d] %d %llx (%llx) %llx\n"
+                       ,num_cache
+                       ,num_cpu
+                       ,          r_dcache_ll_valid [num_cache][num_cpu].read()
+                       ,(uint64_t)r_dcache_ll_addr  [num_cache][num_cpu].read()
+                       ,(uint64_t)set_num_dcache_only(r_dcache_ll_addr [num_cache][num_cpu].read(),num_cache)
+                       ,(uint64_t)r_dcache_ll_data [num_cache][num_cpu].read());
+
+            PRINTF("    * dcache_previous_unc     : [%.2d] %d\n",num_cache,r_dcache_previous_unc[num_cache].read());
+
+#if CC_XCACHE_WRAPPER_DEBUG
+            if (m_cpt_total_cycles>=CC_XCACHE_WRAPPER_DEBUG_CYCLE_MIN)
+                r_wbuf[num_cache]->printTrace(1);
+#endif
+        }
         // CACHE_MISS_BUF_RSP_PRINT(i);
         // CACHE_MISS_BUF_RSP_PRINT(d);
 
-#if CC_XCACHE_WRAPPER_DEBUG
-        if (m_cpt_total_cycles>=CC_XCACHE_WRAPPER_DEBUG_CYCLE_MIN)
-            {
-                r_wbuf.printTrace(1);
-            }
-#endif
+        for (uint32_t num_cache=0; num_cache<m_nb_dcache; ++num_cache)
+        m_cpt_fsm_dcache  [num_cache][r_dcache_fsm[num_cache]] ++;
+        for (uint32_t num_cache=0; num_cache<m_nb_icache; ++num_cache)
+        m_cpt_fsm_icache  [num_cache][r_icache_fsm[num_cache]] ++;
+        m_cpt_fsm_cmd     [r_vci_cmd_fsm] ++;
+        m_cpt_fsm_rsp     [r_vci_rsp_fsm] ++;
+        m_cpt_fsm_tgt     [r_vci_tgt_fsm] ++;
+        m_cpt_fsm_cleanup [r_cleanup_fsm] ++;
 
         m_cpt_total_cycles++;
@@ -626,5 +1164,5 @@
                 if ( p_vci_tgt.cmdval.read() ) 
                 {
-                    PRINTF("    * <TGT> request\n");
+                    PRINTF("    * <TGT> Request\n");
 
                     addr_40 address = p_vci_tgt.address.read();
@@ -634,5 +1172,5 @@
                         std::cout << "error in component VCI_CC_XCACHE_WRAPPER " << name() << std::endl;
                         std::cout << "coherence request is not a write" << std::endl;
-                        std::cout << "oddress = " << std::hex << address << std::dec << std::endl;
+                        std::cout << "address = " << std::hex << address << std::dec << std::endl;
                         std::cout << "srcid   = " << p_vci_tgt.srcid.read() << std::endl;
                         exit(0);
@@ -644,20 +1182,26 @@
                         std::cout << "error in component VCI_CC_XCACHE_WRAPPER " << name() << std::endl;
                         std::cout << "out of segment coherence request" << std::endl;
-                        std::cout << "oddress = " << std::hex << address << std::dec << std::endl;
+                        std::cout << "address = " << std::hex << address << std::dec << std::endl;
                         std::cout << "srcid   = " << p_vci_tgt.srcid.read() << std::endl;
                         exit(0);
                     }
 
-                    r_tgt_addr = (((addr_40) ((p_vci_tgt.be.read() & 0x3) << 32)) | 
-                                 ((addr_40) (p_vci_tgt.wdata.read()))) * m_dcache_words * 4;      
-                    r_tgt_srcid = p_vci_tgt.srcid.read();
-                    r_tgt_trdid = p_vci_tgt.trdid.read();
-                    r_tgt_pktid = p_vci_tgt.pktid.read();
-                 // r_tgt_plen  = p_vci_tgt.plen.read();
+                    addr_40 tgt_addr  = ((((addr_40)p_vci_tgt.be.read() & 0x3) << 32) | ((addr_40) p_vci_tgt.wdata.read())) << (addr_40)m_dcache_words_shift;
+                    // * m_dcache_words * 4;
+
+                    addr_40 tgt_iaddr = tgt_addr;
+                    addr_40 tgt_daddr = tgt_addr;
+
+                    PRINTF("    * <TGT> srcid            : %d\n",(uint32_t)p_vci_tgt.srcid.read());
+                    PRINTF("    * <TGT> trdid            : %d\n",(uint32_t)p_vci_tgt.trdid.read());
+                    PRINTF("    * <TGT> pktid            : %d\n",(uint32_t)p_vci_tgt.pktid.read());
+                    PRINTF("    * <TGT> address (before) : %llx\n",(uint64_t)tgt_iaddr);
+
+                    r_tgt_srcid     = p_vci_tgt.srcid.read();
+                    r_tgt_trdid     = p_vci_tgt.trdid.read();
+                    r_tgt_pktid     = p_vci_tgt.pktid.read();
+                 // r_tgt_plen      = p_vci_tgt.plen.read();
                     
-                    PRINTF("    * <TGT> address : %llx\n",(uint64_t)address);
-                    PRINTF("    * <TGT> address : %llx\n",(uint64_t)((((addr_40) ((p_vci_tgt.be.read() & 0x3) << 32)) | 
-                                                                      ((addr_40) (p_vci_tgt.wdata.read()))) * m_dcache_words * 4));
-
+                    // BROADCAST
                     if ( (address&0x3) == 0x3 )   // broadcast invalidate for data or instruction type
                     {
@@ -671,5 +1215,27 @@
                         // r_tgt_brdcast= true;
                         r_vci_tgt_fsm = TGT_REQ_BROADCAST;
+                        uint32_t tgt_num_cache;
+                        tgt_num_cache = get_num_icache(tgt_iaddr,0); // none effect (else CC_XCACHE_WRAPPER_MULTI_CACHE==1)
+                        tgt_num_cache = get_num_dcache(tgt_daddr);
+                        r_tgt_num_cache = tgt_num_cache;
+
+                        PRINTF("    * <TGT> REQ_BROADCAST\n");
+                        PRINTF("    * <TGT> num_cache (data) : %d\n",tgt_num_cache);
+
                         m_cpt_cc_inval_broadcast++ ;
+
+#if CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
+                        {
+                            log_transaction_file_tgt
+                                << "[" << m_cpt_total_cycles << "] "
+                                << "BROADCAST  "
+                                << std::hex
+                                << " L " << std::setw(10) << (uint64_t)tgt_addr
+                                << std::dec
+                                << " - " << tgt_num_cache
+                                << std::endl;
+                        }
+#endif //CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
+
                     }
                     else                    // multi-update or multi-invalidate for data type
@@ -677,4 +1243,5 @@
                         uint32_t cell = address - m_segment.baseAddress(); // addr_40
                         // r_tgt_brdcast = false;
+
                         if (cell == 0) 
                         {                                       // invalidate data
@@ -687,5 +1254,25 @@
                             r_tgt_update = false; 
                             r_vci_tgt_fsm = TGT_REQ_DCACHE;
+                            uint32_t tgt_num_cache = get_num_dcache(tgt_daddr); // static partionnement
+                            r_tgt_num_cache = tgt_num_cache;
+                            
+                            PRINTF("    * <TGT> REQ_DCACHE\n");
+                            PRINTF("    * <TGT> num_cache        : %d\n",tgt_num_cache);
+
                             m_cpt_cc_inval_dcache++ ;
+
+#if CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
+                            {
+                                log_transaction_file_tgt
+                                    << "[" << m_cpt_total_cycles << "] "
+                                    << "INVAL DATA "
+                                    << std::hex
+                                    << " L " << std::setw(10) << (uint64_t)tgt_addr
+                                    << std::dec 
+                                    << " - " << tgt_num_cache
+                                    << std::endl;
+                            }
+#endif //CC_XCACHE_WRAPPER_DEBUG_FILE_TRANSACTION
+
                         } 
                         else if (cell == 4)                     // invalidate instruction
